/*
 * The Modern Classic Game - a 3D/2D game
 * Copyright (C) 2013 Thiago Lasso (SoniEx2)
 * 
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.github.soniex2.tmcg.entity.player.gender;

public abstract class GenderValue {

	protected double min;
	protected double max;
	protected boolean fixed;

	public GenderValue(double d) {
		if (d < 0 || d > 1)
			throw new IllegalArgumentException();
		this.min = d;
		this.max = d;
		this.fixed = true;
	}

	public GenderValue(double min, double max) {
		if (min < 0 || min > 1)
			throw new IllegalArgumentException();
		if (max < 0 || max > 1)
			throw new IllegalArgumentException();
		if (min < max) {
			this.min = min;
			this.max = max;
			this.fixed = false;
		} else if (min > max) {
			this.max = min;
			this.min = max;
			this.fixed = false;
		} else {
			this.min = this.max = min;
			this.fixed = true;
		}
	}

	public abstract double get();

	public String toString() {
		return String.valueOf(get());
	}
}
