package com.github.soniex2.tmcg.ym2612;

public class FMChannel {

	// Always update ops as 0 -> 2 -> 1 -> 3
	// The only thing that changes is the way you feed in/outputs
	// http://nemesis.hacking-cult.org/MegaDrive/Documentation/operators.png
	// This shows the register order:
	// http://nemesis.hacking-cult.org/MegaDrive/Documentation/operator%20registers.png
	// Note how it's 0, 2, 1, 3 instead of 0, 1, 2, 3... This is the oder on
	// how ops are updated, as seen here:
	// http://gendev.spritesmind.net/forum/viewtopic.php?p=21109#21109

	// Operator Update Modes:
	// Order of operands: "+" first, "->" last, unless inbetween ()
	// [x] are slots

	// 0 -> 1 -> 2 -> [3]

	// 0 + 1 -> 2 -> [3]

	// 0 + (1 -> 2) -> [3]

	// (0 -> 1) + 2 -> [3]

	// (0 -> [1]) + (2 -> [3])

	// 0 -> [1] + [2] + [3]
	// AKA feed 0 into 1, 2, and 3

	// (0 -> [1]) + [2] + [3]
	// AKA feed 0 into 1, sum output of 1 with 2 and 3

	// [0] + [1] + [2] + [3]

	protected OperatorUnit[] ops = new OperatorUnit[4];
	protected int opOrder = 0;

	public FMChannel() {
		for (int i = 0; i < ops.length; i++) {
			ops[i] = new OperatorUnit();
			ops[i].setPhaseGenerator(new PhaseGenerator());
		}
	}

	public OperatorUnit getOp(int i) {
		return ops[i];
	}

}
